/*
 * MediaRepository is a baseclass for all communication interfaces
 * (e.g. files, tcp, rtp and http streams)
 *
 * Copyright (C) 2008 Joern Seger
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef MEDIAREPOSITORY_H_
#define MEDIAREPOSITORY_H_

#include "definition.h"
#include "mediaUnit.h"
#include "rawMediaPacket.h"

class MediaRepository : public MediaUnit {

 protected:
  bool repositoryAvailable;

 public:
  MediaRepository(MediaDirection_t type, std::string name);
  virtual ~MediaRepository();

  virtual bool isAvailable();

  virtual MediaUnit& operator<<(RawMediaPacket& packet) = 0;
  virtual MediaUnit& operator>>(RawMediaPacket& packet) = 0;

  virtual uint32 getBunchSize() = 0;
  virtual void setBunchSize(uint32 size) = 0;

};

#endif /*MEDIAREPOSITORY_H_*/
