/*
 * OggDecoder
 *
 * Copyright (C) 2008 Joern Seger
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#ifndef OGGDECODER_H_
#define OGGDECODER_H_

#include <list>
#include <vector>

#include "mediaDecoder.h"
#include "rawMediaPacket.h"
#include "oggPage.h"
#include "oggRingbuffer.h"

class OggDecoder : public MediaDecoder {

 protected:
   OggRingbuffer              oggRingbuffer;
   std::list<OggPage>         oggPageList;

   void getNextPages();

 public:
  OggDecoder();
  virtual ~OggDecoder();

  virtual OggDecoder& operator<<(RawMediaPacket& mediaPacket);
  virtual OggDecoder& operator>>(OggPage& packet);

};

#endif /*OGGDECODER_H_*/
